
/* dosalloc.c  EOUE Project, 1997 by Michael Mangelsdorf */
/* THIS FILE IS PUBLIC DOMAIN.
   LEAVE THIS MESSAGE IN PLACE AS COURTESY TO THE AUTHOR */


#include <stdio.h>
#include <dos.h>

typedef unsigned char  byte;

/* When a .exe is loaded by DOS, all available memory is allotted
   to it. ES then points to beginning, SS:SP to end of program.
   We compute the difference SS:SP and ES, keep that and release
   the rest.
*/
void libermem (void)
{
  asm {
     mov bx,ss; mov ax,es; sub bx,ax; mov ax,sp; add ax,0x15
     mov cl,0x04; shr ax,cl; add bx,ax; mov ah,0x4A; int 0x21
  }
}

/* Tries to allocate memory via DOS function call.
   If successful, dosmemseg points to base of possibly
   more than 64k sized memory block. One paragraph
   is sixteen bytes.
   Failing function returns true.
*/
byte dosalloc (unsigned paragraphs, unsigned *dosmemseg) {
 union REGS r;
   r.h.ah=0x48; r.x.bx=paragraphs+1; int86(0x21,&r,&r);
  *dosmemseg=r.x.ax;         /* +1 is space for DOS MCB */
   return r.x.cflag;
}


/* De-allocate DOS-memory
   Failing function returns true
*/
byte dosdealloc (unsigned dosmemseg) {
 union REGS r; struct SREGS s;
   s.es=dosmemseg; r.h.ah=0x49; int86x(0x21,&r,&r,&s);
   return r.x.cflag;
}

